unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  ShellApi;// Cette Unit est  ajouter.

type
  TForm1 = class(TForm)
    EditNomFichier: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EditParametre: TEdit;
    Label3: TLabel;
    EditDossier: TEdit;
    Button1: TButton;
    Button2: TButton;
    ButtonUtilisationFonctionLanceFichier: TButton;
    Memo1: TMemo;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonUtilisationFonctionLanceFichierClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

function LanceFichier(NomFichier : string; Parametre : String; Dossier: String) : HINST;

implementation

{$R *.DFM}


//Ancienne mthodes (D1)---------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
  NomProgramme         :array[0..255]of char;
  ParametreDuProgramme :array[0..255]of char;
  DirectoryParDefaut   :array[0..255]of char;
begin
  StrPCopy(NomProgramme         ,EditNomFichier.Text);
  StrPCopy(ParametreDuProgramme ,'"'+EditParametre.Text+'"');
  StrPCopy( DirectoryParDefaut  ,EditDossier.Text);
  ShellExecute (handle,'Open',  NomProgramme ,ParametreDuProgramme,
                     DirectoryParDefaut,SW_SHOWNORMAL);
end;


// Nouvelle mthode (D3)-----------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
Var parametre:string;
begin
  Parametre:='"'+EditParametre.Text+'"';
  ShellExecute (handle,'Open',  PChar(EditNomFichier.Text) ,PChar(Parametre),
                     PChar(EditDossier.Text),SW_SHOWNORMAL);
end;


{utilisation de LanceFichier (le plus simple) -------------------}

procedure TForm1.ButtonUtilisationFonctionLanceFichierClick(
  Sender: TObject);
begin
  LanceFichier(EditNomFichier.Text, EditParametre.Text, EditDossier.Text);
end;

{ ----------------------------------------------------------------}
{ fonction permettant de lancer facilement un fichier ou programme}
{ ----------------------------------------------------------------}
function LanceFichier(NomFichier : string; Parametre : String; Dossier: String) : HINST;
begin
   IF Parametre<>'' then Parametre:='"'+Parametre+'"';
   Result:=ShellExecute (Application.handle,'Open',  PChar(NomFichier) ,PChar(Parametre),PChar(Dossier),SW_SHOWNORMAL);
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then EditNomFichier.Text:=OpenDialog1.FileName;
end;

end.



